
#include <arch/arch.h>
#include <arch/types.h>
#include <drivers/rtc/rtc.h>
#include <drivers/key/key.h>
#include <drivers/serial/serial.h>

void Irq_Handler(int32u irqno)
{
	switch (irqno) {
		case BIT31:	// RTC Alarm Match Register Interrupt
			SerialOutputString("[31]\n");
			rtc_alarm_handler();
			break;
		case BIT30:	// RTC Hz Clock Tick Interrupt
			rtc_handler();
			break;
		case BIT29:	// 
			SerialOutputString("[29]\n");
			break;
		case BIT28:	// 
			SerialOutputString("[28]\n");
			break;
		case BIT27:	// 
			SerialOutputString("[27]\n");
			break;
		case BIT26:	// 
			SerialOutputString("[26]\n");
			break;
		case BIT25:	// 
			SerialOutputString("[25]\n");
			break;
		case BIT24:	// 
			SerialOutputString("[24]\n");
			break;
		case BIT23:	// 
			SerialOutputString("[23]\n");
			break;
		case BIT22:	// 
			SerialOutputString("[22]\n");
			break;
		case BIT21:	// 
			SerialOutputString("[21]\n");
			break;
		case BIT20:	// 
			SerialOutputString("[20]\n");
			break;
		case BIT19:	// 
			SerialOutputString("[19]\n");
			break;
		case BIT18:	// 
			SerialOutputString("[18]\n");
			break;
		case BIT17:	// 
			SerialOutputString("[17]\n");
			break;
		case BIT16:	// 
			SerialOutputString("[16]\n");
			break;
		case BIT15:	// 
			SerialOutputString("[15]\n");
			break;
		case BIT14:	// 
			SerialOutputString("[14]\n");
			break;
		case BIT13:	// 
			SerialOutputString("[13]\n");
			break;
		case BIT12:	// 
			SerialOutputString("[12]\n");
			break;
		case BIT11:	// 
			SerialOutputString("[11]\n");
			break;
		case BIT10:	// 
			SerialOutputString("[10]\n");
			break;
		case BIT9:	// 
			SerialOutputString("[09]\n");
			break;
		case BIT8:	// 
			key_handler();
			break;
		case BIT7:	// 
			SerialOutputString("[07]\n");
			break;
		case BIT6:	// 
			SerialOutputString("[06]\n");
			break;
		case BIT5:	// 
			SerialOutputString("[05]\n");
			break;
		case BIT4:	// 
			SerialOutputString("[04]\n");
			break;
		case BIT3:	// 
			SerialOutputString("[03]\n");
			break;
		case BIT2:	// 
			SerialOutputString("[02]\n");
			break;
		case BIT1:	// 
			SerialOutputString("[01]\n");
			break;
		case BIT0:	// 
			SerialOutputString("[00]\n");
			break;
		default:
			SerialOutputString("default!!\n");
			break;
	}
	//_nop_loop();
}

