.global	Port_Init
.global	Port_ThreadSwitch
.global  Port_CriticalSectionEnter
.global	Port_CriticalSectionLeave
.global Port_InterruptEnable
.global Port_InterruptDisable

.extern pNextThread_g
.extern pCurrThread_g

Port_ThreadSwitch:
;	// sp <= pNextThread_g->pStack
	ldr	r0, =pNextThread_g
	ldr r1, =pCurrThread_g
	ldr r1, [r1]
	str r0, [r1]

	ldr	r0, [r0]
	ldr	sp, [r0]
;	// Load context & Run task
	ldmfd	sp!, {r0}
	msr	cpsr_cxsf, r0
	ldmfd	sp!, {r0-r12, lr, pc}

//----------------- Enable I-bit & F-bit
Port_InterruptEnable:
	stmfd	sp!, {r0, lr}

	mrs	r0, cpsr
	bic	r0, r0, #0xc0
	msr	cpsr, r0
	ldmfd	sp!, {r0, pc}


//----------------- Disable I-bit & F-bit
Port_InterruptDisable:
	stmfd	sp!, {r0, lr}

	mrs	r0, cpsr
	orr	r0, r0, #0xc0
	msr	cpsr, r0

	ldmfd	sp!, {r0, pc}

Port_Init:
	mov	pc, lr

