
.text
#include <arch/config.h>

.global _Start
.extern Port_InterruptEnable

//----------------- Start code
_Start:
	b	_Reset
	b	_Exception_undef		// undefined_instruction
	b	_Exception_swi			// software_interrupt
	b	_Exception_pabort		// abort_prefetch
	b	_Exception_dabort		// abort_data
	b	.				// not_used
	b	_Exception_irq			// interrupt_request
	b	_Exception_fiq			// fast_interrupt_request


//----------------- Initialize target board
_Reset:
//	bl	_Init_board


//----------------- Clear bss area
	mov	r0, #0			// r0 = Init value (#0)
	ldr	r1, =_bss_start		// r1 = Start address
	ldr	r2, =_bss_end		// r2 = End address
	sub	r2, r2, r1		// r2 = bss size

_Loop_bss_init:
	stmia	r1!, {r0}
	subs	r2, r2, #4
	bne	_Loop_bss_init


//----------------- Set several mode stack
	mrs	r0, cpsr
	bic	r0, r0, #0x1f
	ldr	r2, =_stack_start

	orr	r1, r0, #0xd1		// fiq mode
	msr	cpsr, r1
	sub	sp, r2, #_STACK_FIQ

	orr	r1, r0, #0xd2		// irq mode
	msr	cpsr, r1
	sub	sp, r2, #_STACK_IRQ

	orr	r1, r0, #0xd3		// svc mode
	msr	cpsr, r1
	sub	sp, r2, #_STACK_SVC

	orr	r1, r0, #0xd7		// abort mode
	msr	cpsr, r1
	sub	sp, r2, #_STACK_ABORT

	orr	r1, r0, #0xdb		// undef mode
	msr	cpsr, r1
	sub	sp, r2, #_STACK_UNDEF

	orr	r1, r0, #0xdf		// sys mode
	msr	cpsr, r1
	sub	sp, r2, #_STACK_SYS



//----------------- Enable I-bit & F-bit
	bl	Port_InterruptEnable


//----------------- Jump to main
	ldr	r0, =C_Entry
	mov	pc, r0





/*
relocate:
	ldr	r0, =_init_end		// r0 = Source position
	add	r2, r0, #(64*1024)	// r2 = End point to compare
	ldr	r1, =sdram_start	// r1 = Destination position

copy_loop:
	ldmia	r0!, {r3 - r10}
	stmia	r1!, {r3 - r10}
	cmp	r0 ,r2
	ble	copy_loop
*/
