
#include <arch/arch.h>
#include <drivers/fnd/fnd.h>
#include <drivers/serial/serial.h>



char Getsegcode(int x);


void fnd_display(unsigned short *fnd_value)
{
	int i;

	for (i = 0; i < 6; i++)
		FND_REG = fnd_value[i];
}

unsigned short fnd_segment(int value, int dp, int digit)
{
	char code;

	code = Getsegcode(value);
	if (dp)
		code |= 0x80;

	return (unsigned short)((code << 8) | (0xff & ~(0x1 << digit)));
}

char Getsegcode(int x)
{
  char code;

  switch(x) {
    case 0x0 : code = 0x3f; break;
    case 0x1 : code = 0x06; break;
    case 0x2 : code = 0x5b; break;
    case 0x3 : code = 0x4f; break;
    case 0x4 : code = 0x66; break;
    case 0x5 : code = 0x6d; break;
    case 0x6 : code = 0x7d; break;
    case 0x7 : code = 0x07; break;
    case 0x8 : code = 0x7f; break;
    case 0x9 : code = 0x6f; break;
    case 0xA : code = 0x77; break;
    case 0xB : code = 0x7c; break;
    case 0xC : code = 0x39; break;
    case 0xD : code = 0x5e; break;
    case 0xE : code = 0x79; break;
    case 0xF : code = 0x71; break;
    default : code = 0x7f; break;
  }

  return code;
}

