
#include <drivers/lcd/define.h>
#include <drivers/lcd/lcdapp.h>

const unsigned char table[3][32]=
    {  {  0, 0, 1, 2, 3, 4, 5, 6,  7, 8, 9,10,11,12,13,14,
         15,16,17,18,19, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0 },
       {  0, 0, 0, 1, 2, 3, 4, 5,  0, 0, 6, 7, 8, 9,10,11,
          0, 0,12,13,14,15,16,17,  0, 0,18,19,20,21, 0, 0 },
       {  0, 0, 1, 2, 3, 4, 5, 6,  7, 8, 9,10,11,12,13,14,
         15,16, 0,17,18,19,20,21, 22,23,24,25,26,27, 0, 0 }
    };
const unsigned char fsttable[2][20]=
    {   { 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1 },
        { 0, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 3, 3, 3 }
    };
const unsigned char midtable[3][22]=
    {   { 0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0, 2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1 },
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0 },
        { 0, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7, 7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5 }
    };

int LOAD_FONT(char *,char *);
void HPRINTF(int,int,int,char *);
void PUT_FONT(int,int,int,unsigned char *,int);
void OR_HAN( unsigned char *,unsigned char *,int);

unsigned char H_FONT1[8][20][32];
unsigned char H_FONT2[4][22][32];
unsigned char H_FONT3[4][28][32];
unsigned char H_EXIT[32];

unsigned char E_FONT[256][16];
unsigned char E_EXIT[16];

int LOAD_FONT(char *hfont,char *efont)
{
  char *hfnt = hfont;
  char *efnt = efont;
  MemCpy(H_FONT1, hfnt, 5120);
  MemCpy(H_FONT2, &hfnt[5120], 2816);
  MemCpy(H_FONT3, &hfnt[5120+2816], 3584);
//   H_FONT1 = (unsigned char *)hfnt;
//   H_FONT2 = (unsigned char *)hfnt+5120;
//   H_FONT3 = (unsigned char *)&hfnt+(5120+2816);

  MemCpy(E_FONT, efnt, 4096);
//   E_FONT = efnt;
  return 0;
/*
        FILE *fpfnt;
        fpfnt = fopen(hfont,"rb");
        if (fpfnt != NULL)
        {
                fread(H_FONT1,5120,1,fpfnt);
                fread(H_FONT2,2816,1,fpfnt);
                fread(H_FONT3,3584,1,fpfnt);
        }else return(1);
        fclose(fpfnt);

        fpfnt = fopen(efont,"rb");
        if (fpfnt != NULL)
        {
                fread(E_FONT,4096,1,fpfnt);
        }else return(1);
        fclose(fpfnt);
        return(0);*/
}

void HPRINTF(int x, int y, int color, char *s)
{
        unsigned char data1, data2;
        unsigned char first, mid, last;
        int j,i, b1, b2, b3;

        for ( i = 0; i < StrLen(s); i++ )
        {
                data1 = *( s + i );
                MemSet(H_EXIT,0,32);
                MemSet(E_EXIT,0,16);
        if ( data1 > 127 )
        {
                data2 = *( s + (++i) );
                first = ( data1 & 124 ) >> 2;
                mid   = ( data1 & 3   ) * 8 + (data2 >> 5);
                last  = ( data2 & 31  );
                first = table[0][first];
                mid   = table[1][mid];
                last  = table[2][last];

                b3    = midtable[0][mid];
                if (!last)
                {
                        b2 = fsttable[0][first];
                        b1 = midtable[1][mid];
                }
                else
                {
                        b2 = fsttable[1][first];
                        b1 = midtable[2][mid];
                }
                if (first) OR_HAN(H_FONT1[b1][first], H_EXIT, 32);
                if (mid  ) OR_HAN(H_FONT2[b2][mid  ], H_EXIT, 32);
                if (last ) OR_HAN(H_FONT3[b3][last ], H_EXIT, 32);
                PUT_FONT( x, y, color, H_EXIT, 16);
                x += 16;
        }
        else
        {
                for (j=0; j<16; j++)
                E_EXIT[j] = E_FONT[data1][j];

                PUT_FONT( x, y, color, E_EXIT, 8);
                x += 8;
        }
    }
}

void OR_HAN( unsigned char *src, unsigned char *dest, int size )
{
        int i;
	for ( i = 0; i < size; i++ ) dest[i] |= src[i];
}

void PUT_FONT(int dx, int dy, int color, unsigned char *fnt, int size)
{
  int x,y,m=0,n=0;
  unsigned char dat = 0x80;
  long int offset;

  for (y=dy;y<dy+16;y++)
  {
    for (x=dx;x<dx+size;x++)
    {
      if ((fnt[m]&(dat>>n)) == (dat>>n)) LCD_START_BUF[y*640+x] = color;
      if ((++n) == 8) {n=0; m+=1;}
    }
  }
}



