/************************************************************/
/* Program Assignment: util.c                               */
/* version           : ver 0.1.0.0                          */
/* author            : jaeyou Yang (hackedhouse@hotmail.com */
/* data              : 2005-08-02                           */
/* Modified by       : Min Kyu Hwang (middlism@smu.ac.kr)   */
/* Modified at       : 2005-10-08                           */
/* Description       : help for job process                 */
/************************************************************/

#include <drivers/lcd/util.h>
// added by Taewoo,K. 
#include <drivers/lcd/types.h>
//#include <net.h>
//--------------------
//#include "serial.h"

/* added key_input func by mwk */



unsigned char key_input(void)
{
  unsigned short temp;
  unsigned char temp1;
    
  temp = *(unsigned short*)(0x14000000);
  temp1 = (unsigned char)(temp & 0x0F);
  return temp1;
}


void MemCpy(void *dest, void *src, int cnt){
  char *s1=dest, *s2=src, *endptr=(char *)dest+cnt;

  while (s1<endptr)
    *s1++ = *s2++;
  return;
}


void MemCpyChar(char *cDest, const char *cSrc, int iLength)
{
  while(iLength--)
    *cDest++ = *cSrc++;
}

//Modified by Hwang M.K.-----------------------------------
void MemSet(unsigned char *uDest, const unsigned char Setvalue,int iSize)
{
  while(iSize--)
    *uDest++ = Setvalue;
}
//---------------------------------------------------------

int MemCmp(void *vCmp1, void * vCmp2, int iSize)
{
  while(iSize--)
    {
      if((unsigned long)vCmp1 != (unsigned long)vCmp2)
	return ((unsigned long)vCmp1 - (unsigned long)vCmp2);
      else
	vCmp1++,vCmp2++;
    }
  return 0;
}

// added by Taewoo,K.--------------------------------------  
int IpOrMacCmp(void *addr1, void *addr2, int len){
        volatile char *s1=addr1, *s2=addr2;
        volatile char *endptr = addr1+len;
                                                                                             
        while ((ulong)s1 < (ulong)endptr){
                if (*s1++ != *s2++) return *(--s1) - *(--s2);
        }
        return 0;
}

void IpOrMacMemSet(void *dest, char c, int len){
                char *s=dest;
                        char *limit = (char *)dest+len;
                                
				while (s < limit) *s++ = c;
}

// ---------------------------------------------------------

void StrCpy(char *cDest, char *cSrc)
{
  char *cD = cDest, *cS = cSrc;

  while(*cS != '\0')
    *cD++ = *cS++;
  *cD = '\0';
}


int StrLen(char *cDest)
{
  int i=0;
  for(; *(cDest+i) != '\0'; i++);
  return i;
}


int StrNCmp(char *cString1, char *cString2, int iLength)
{
  int i;
  for(i=0; i<iLength ; i++)
    {
      if (cString1[i] != cString2[i])
	return ((int)cString1[i] - ((int)cString2[i]));
      if(cString1[i] == 0)
	return 0;
    }
  return 0;
}


//Modified by Hwang M.K
//  0   
int StrCmp(char *cString1, char *cString2)
{
        for (; *cString1 && *cString2; cString1++, cString2++)
        {
                if (*cString1 != *cString2) return ((int)(*cString1) - (int)(*cString2));
        }
        if (*cString1 || *cString2) return ((int)(*cString1) - (int)(*cString2));
        return 0;
}



int aToi(char *cStr)
{
  int iDest;
  int iVal;

  for(iVal=0; *cStr; cStr++)
    {
      iDest = *cStr - '0';
      iVal = iVal*10 +iDest;
    }
  return iVal;
}


unsigned long aToul(char *cStr)
{
  unsigned long uDest;
  unsigned long uVal;
  char *cTmp = cStr;

  if(StrNCmp(cStr,"0x",2) == 0)
    {
      cTmp = cTmp +2;
    }

  for(uVal=0; *cTmp; cTmp++)
    {
      if(*cTmp < 'a')
	{
	  uDest = *cTmp - '0';
	  uVal = uVal*16 + uDest;
	}
      else
	{
	  uDest = *cTmp +10 - 'a';
	  uVal = uVal*16 + uDest;
	}
    }
  return uVal;
}

//product by Hwang M.K--------------------------------------------------------

//(ȣ ִ)ڸ ڿ ٲش. (nOutRadix 10   ǥ)
	//nInput     - ڿ ȯ ġ   
	//szOutput   -  ޵ ڿ 
	//nOutRadix  - ڿ  ·  (2~35)
	//RETURN - szOutput ּҸ Ͽ, 깮 ȿ    ֵ 


char * lToaX(long nInput, char *szOutput, unsigned long nOutRadix) 
{ 
	long k, i, n, minus = 0;
	char c;
	if (nInput < 0 && nOutRadix == 10) { 
		szOutput[0] = '-'; 
		minus = 1;
		nInput *= -1; 
	}else if (nInput == 0)
	{
		szOutput[0] = '0';
		szOutput[1] = '\0';
		return szOutput;
	}

	for (i=minus;nInput != 0;i++)
	{
		n = nInput%nOutRadix;
		szOutput[i] = (n < 10)? n+48 : n+55;
		nInput/=nOutRadix;
	}
	szOutput[i] = '\0';
	i--;

	for (k=minus; i-k > 0; i--,k++)
	{
		c = szOutput[i];
		szOutput[i] = szOutput[k];
		szOutput[k] = c;
	}
	return szOutput; 
} 
//(ȣ )ڸ ڿ ٲش. (nOutRadix    ǥ)
	//nInput     - ڿ ȯ ġ   
	//szOutput   -  ޵ ڿ 
	//nOutRadix  - ڿ  ·  (2~35)
	//RETURN - szOutput ּҸ Ͽ, 깮 ȿ    ֵ 
char * ulToaX(unsigned long nInput, char *szOutput, unsigned long nOutRadix) 
{ 
	int k, i, n;
	char c;
	if (nInput == 0)
	{
		szOutput[0] = '0';
		szOutput[1] = '\0';
		return szOutput;
	}
	for (i=0;nInput != 0;i++)
	{
		n = nInput%nOutRadix;
		szOutput[i] = (n < 10)? n+48 : n+55;
		nInput/=nOutRadix;
	}
	szOutput[i] = '\0';
	i--;

	for (k=0; i-k > 0; i--,k++)
	{
		c = szOutput[i];
		szOutput[i] = szOutput[k];
		szOutput[k] = c;
	}
	return szOutput;
}

//ڿ ڷ ٲش. 
    //szInput : ڷ ٲ ڿ 
    //nInRadix :  ڿ   (2~35)
    //RETURN : ڷ ٲ   
long aTolX(char *szInput, unsigned long nInRadix) 
{ 
	long n=0, x=0, i=0, value=0, total=0, nExponent=1, minus=0;
	char *tmp = szInput;
	while (*tmp!=0) tmp++;
	n = tmp - szInput; 
	if (szInput[0] == '-') { 
		szInput[0] = '0'; 
		minus = 1; 
	} 

  do 
  { 
     value = szInput[i++]; 
     if (value >= '0' && value <= '9') 
       value -= 48; 
     else if (value >= 'A' && value <= 'Z') 
       value = value - 65 + 10; 
     else if (value >= 'a' && value <= 'z') 
       value = value - 97 + 10; 
     nExponent=1; 
     for (x=--n; x > 0; x--) 
        nExponent = nExponent*nInRadix; 
     total += (value * nExponent); 
  } while (szInput[i] != '\0'); 

  if(minus) 
    total *= -1; 

  return total; 
} 

// Ǵϴ Լ
	//cDigit :  Ǵ 
	//nRadix :  ڰ   Ǵ  (2~35)
	//RETURN : ΰ 0 ڰ ƴѰ -1
int IsDigitX(char cDigit, unsigned long nRadix)
{

 if (nRadix <= 10)
 {
  if (cDigit >= '0' && cDigit <= (char)('0'+nRadix-1))
   return 0;
 }else
 {
  if (cDigit >= '0' && cDigit <= '9')
   return 0;
  else if ((cDigit >= 'a' && cDigit <= (char)('a'+(nRadix-10)-1)) \
   || (cDigit >= 'A' && cDigit <= (char)('A'+(nRadix-10)-1)))
   return 0;
 }
 return -1;
}


//------------------------------------------------------------------






// added by Taewoo,K. ----------------------------------------------
unsigned long inet_addr(char* ipaddr)
{
        unsigned char temp[3],i=0,value=0,j=0,k;
        unsigned long ip =0,ipt=0;
                                                                                             
        for(k = 0 ; k < 3; k++) temp[k] = 0;
        while(*(ipaddr) != '\0'){
                if( *ipaddr != '.'){
                        temp[i] = *ipaddr - 0x30;
                        ipaddr++;i++;
                }
                else{
                        if(i == 1){
                                 value = temp[0];
                        }
                        else if(i == 2){
                                 value = temp[1]+ temp[0]*10;
                        }
                        else if(i == 3){
                                 value = temp[2] + temp[1]*10 + temp[0]*100;
                        }
                        ipt = value;
                        ip |= ipt << (j*8); j++;
                        ipaddr++;
                        for(k = 0 ; k < 3; k++) temp[k] = 0;
                        i = 0;
                }
        }
        if(i == 1){
                 value = temp[0];
        }
        else if(i == 2){
                 value = temp[1]+ temp[0]*10;
        }
        else if(i == 3){
                 value = temp[2] + temp[1]*10 + temp[0]*100;
        }
        ipt = value;
        ip |= ipt << (j*8); j++;
                                                                                             
        return (ip);
}
#if 0
int StrToEtherAddr(unsigned char *envEtherAddr,char *ethAddr){
        int i,envCnt=0;
        char strMacNum[3];
        int numCnt;
        
	for(i=1;i<=18;i++){
                numCnt=i%3;
                if(numCnt!=0){
                        if(IsDigitX(ethAddr[i-1],16)) return -1;
                        strMacNum[numCnt-1]=ethAddr[i-1];
                }
                else if(numCnt==0){
                        strMacNum[2]='\0';
                        envEtherAddr[envCnt]=(unsigned char)aTolX(strMacNum,16);
                        envCnt+=1;
                }
        }
        return 0;
}
#endif

// ----------------------------------------------------------------------- 




/* Old version



int StrCmp(char *cString1, char *cString2)
{
  for(;*cString1 && *cString2; cString1++,cString2++)
    {
      if(*cString1 != *cString2)
        return ((int)(*cString1) - (int)(*cString2));
      if(*cString1 || *cString2)
        return ((int)(*cString1) - (int)(*cString2));
    }
  return 0;
}

void MemSet(unsigned long *uDest, const unsigned long *uSetvalue,int iSize)
{
  while(iSize--)
    *uDest++ = *uSetvalue;
}
*/

void udelay(int delay)
{
  int i;
  for( i = 67 * delay; i ; i--)
    ;
}

