
#include <arch/arch.h>
#include <drivers/textlcd/textlcd.h>
#include <drivers/serial/serial.h>

void delayed(int);

void textlcd_init(void)
{
	function_set(2,0); //Function Set:8bit,display 2lines,5x7 mod
	display_control(1,0,0); // Display on, Cursor off

	clear_display(); // Display clear
	entry_mode_set(1,0); // Entry Mode Set : shift right cursor
	return_home(); // go home
	delayed(2000);
}

int textlcd_write(const struct strcommand_varible gdata, size_t length) 
{
	struct strcommand_varible strcommand;

//	copy_from_user(&strcommand,gdata,32);
	strcommand = gdata;

	if(strcommand.rows == 0)
		write_string(0,strcommand.buf,strcommand.strlength);
	else if(strcommand.rows == 1)
		write_string(1,strcommand.buf,strcommand.strlength);
	return length;
}

#if 0
// define functions...
int textlcd_ioctl(unsigned int cmd, unsigned long gdata)
{
	struct strcommand_varible *strcommand;

//	copy_from_user(&strcommand,(char *)gdata,32);
	strcommand = gdata;
	switch(cmd){
		case LCD_COMMAND_SET:
			setcommand(strcommand.command);
			break;
		case LCD_FUNCTION_SET:
			function_set((int)(strcommand.rows+1),(int)(strcommand.nfonts));
			break;
		case LCD_DISPLAY_CONTROL:
			display_control((int)strcommand.display_enable,(int)strcommand.
			cursor_enable,(int)strcommand.nblink);
			break;
		case LCD_CURSOR_SHIFT:
			cusrsor_shit((int)strcommand.set_screen,(int)strcommand.set_rightshit);
			break;
		case LCD_ENTRY_MODE_SET:		
			entry_mode_set((int)strcommand.increase,(int)strcommand. nshift);
			break;
		case LCD_RETURN_HOME:
			return_home();
			break;
		case LCD_CLEAR:
			clear_display();
			break;
		case LCD_DD_ADDRESS:
			set_ddram_address((int)strcommand.pos);
			break;
		case LCD_WRITE_BYTE:
			writebyte(strcommand.buf[0]);
			break;
		default:
			SerialOutputString("driver : no such command!\n");
			return -1;
	}
	return 0;
}
#endif

int set_ddram_address(int pos)
{
	unsigned short command = 0x80;

	command += pos;
	setcommand(command);
	return 1;
}

void writebyte(char ch)
{
	unsigned short data;

	data = ch & 0xff;
	LCD_DATA_REG = data;		
	delayed(50);
}

int function_set(int rows, int nfonts) 
{
	unsigned short command = 0x30;	

	if(rows == 2) command |= 0x08;
	else if(rows == 1) command &= 0xf7;
	else return -1;
	
	command = nfonts ? (command | 0x04) : command;
	setcommand(command);
	return 1;
}

int cusrsor_shit(int set_screen, int set_rightshit)
{
	unsigned short command = 0x10;

	command = set_screen ? (command | 0x08) : command;
	command = set_rightshit ? (command | 0x04) : command;
	setcommand(command);
	return 1;
}

void setcommand(unsigned short command)
{		
	command &= 0xff;
	LCD_INST_REG = command;	
	delayed(50);
}

int return_home()
{
	unsigned short command = 0x02;
	
	setcommand(command);
	delayed(2000);
	return 1;
}

int entry_mode_set(int increase, int nshift)
{
	unsigned short command = 0x04;
	
	command = increase ? (command | 0x2) : command;
	command = nshift ? ( command | 0x1) : command;
	setcommand(command);
	return 1;
}

int clear_display(void)
{
	unsigned short command = 0x01;
	
	setcommand(command);
	delayed(2000);
	return 1;
}

int display_control(int display_enable, int cursor_enable, int nblink)
{
	unsigned short command = 0x08;

	command = display_enable ? (command | 0x04) : command;
	command = cursor_enable ? (command | 0x02) : command;
	command = nblink ? (command | 0x01) : command;

	setcommand(command);
	return 1;
}


void write_string(int row, char *str,int length)
{
	int i;
	unsigned short command = 0x80;
	unsigned short data;

	command = row ? command + 0x40 : command;
	setcommand(command);	
	for(i=0;i<length;i++) {
		data = (*(str + i) & 0xff);
		LCD_DATA_REG = data;		
		delayed(50);
	}
}

void delayed(int n)
{
	int i;

	for( i = 67 * n; i ; i--) ;
}
