#ifndef _TEXTLCD_H_
#define _TEXTLCD_H_

#include <arch/types.h>

#define LCD_INSTRUCTION_ADDRESS		0xC000014
#define LCD_DATA_ADDRESS		0xC000012
#define LCD_INST_REG		*(vint32u *)(LCD_INSTRUCTION_ADDRESS)
#define LCD_DATA_REG		*(vint32u *)(LCD_DATA_ADDRESS)

#define LCD_COMMAND_SET 	0
#define LCD_FUNCTION_SET 	1
#define LCD_DISPLAY_CONTROL	2	
#define LCD_CURSOR_SHIFT 	3
#define LCD_ENTRY_MODE_SET 	4
#define LCD_RETURN_HOME 	5
#define LCD_CLEAR		6
#define LCD_DD_ADDRESS		7
#define LCD_WRITE_BYTE		8


struct strcommand_varible {
	char rows;
	char nfonts;
	char display_enable;
	char cursor_enable;
	char nblink;
	char set_screen;
	char set_rightshit;
	char increase;
	char nshift;
	char pos;
	char command;
	char strlength;
	char buf[20];
};

void textlcd_init(void);
int textlcd_write(const struct strcommand_varible, size_t); 
void write_string(int row, char *str, int length);
void writebyte(char ch);
void setcommand(unsigned short command);

int function_set(int rows, int nfonts);
int display_control(int display_enable, int cursor_enable, int nblink);
int cusrsor_shit(int set_screen, int set_rightshit);
int entry_mode_set(int increase, int nshift);
int return_home(void);
int clear_display(void);
int set_ddram_address(int pos);
int textlcd_ioctl(unsigned int cmd,unsigned long gdata);




#endif // _TEXTLCD_H_
