/*************************************************************************** 
 * File        : interrupt.c
 * Date        : 2007/03/05
 * Author      : Sun Joon Gyu
 * Modified    : 2007/05/27     
 * Description : 
 * ***************************************************************************/
#include<kernel/thread.h>
#include<kernel/list.h>
#include<kernel/schedule.h>


extern waitList_t *pBlockedList_g;





/*************************************************************************** 
 * Function    : Kern_TickISR()
 * Date        : 
 * Author      : 
 * Parameter   : 
 * Return value:
 * Description : 
 * ***************************************************************************/

void 
Kern_TickISR()
{

	tcb_t *iter;

	if(!ListEmpty(&pBlockedList_g->threadList)){
		ListForEachEntry(iter,&pBlockedList_g->threadList,threadList){
			iter->tickDly--;
			//printf("tickDly = %d \n", iter->tickDly);

			if(iter->tickDly == 0){
				tcb_t *temp_tcb = ListEntry(iter->threadList.prev,tcb_t, threadList);

				Kern_WakeThread(iter);

				iter = temp_tcb;

			}

		}
	}

#ifdef SCHED_DRR /* Dynamic Round Robin */
	int32u *timeSlice = &CurrentThread()->timeSlice;
	if(--(*timeSlice) > 0) 
		return;
	else
		Kern_Sched();
#endif // SCHED_DRR
	
}
