/*************************************************************************** 
 * File        : iosubsys.c
 * Date        : 2007/04/25
 * Author      : Sun Joon Gyu
 * Modified    : 2007/04/25
 * Description : 
 * ***************************************************************************/
#include<kernel/iosub.h>
#include<kernel/mm.h>
#include<drivers/serial/serial.h>
//#include<arch/cpu.h>



/*************************************************************************** 
 * Function    : 
 * Date        : 
 * Author      : 
 * Parameter   : 
 * Return value:
 * Description : 
 * ***************************************************************************/

int8s 
Kern_RegisterDev(int8u devNum,void *Dev_Create,void *Dev_Open, void *Dev_Read,
		void *Dev_Write, void *Dev_Close, void *Dev_Ioctl,void *Dev_Destroy)
{
CRITICAL_SECTION_ENTER();
	if(pDevTable_g[devNum] == NULL){
		pDevTable_g[devNum] = (dev_op_t *)MemAlloc((size_t)sizeof(struct device_operation));
CRITICAL_SECTION_LEAVE();
		dev_op_t *pDev_Op = (dev_op_t *)pDevTable_g[devNum];
		pDev_Op->Create = (int32s (*)()) Dev_Create; 
		pDev_Op->Open = (int32s (*)()) Dev_Open;
		pDev_Op->Read = (int32s (*)()) Dev_Read;
		pDev_Op->Write = (int32s (*)()) Dev_Write;
		pDev_Op->Close = (int32s (*)()) Dev_Close;
		pDev_Op->Ioctl = (int32s (*)()) Dev_Ioctl;
		pDev_Op->Destroy = (int32s (*)()) Dev_Destroy;
	}else {
		return FALSE;
	}

	return TRUE;
}





/*************************************************************************** 
 * Function    : 
 * Date        : 
 * Author      : 
 * Parameter   : 
 * Return value:
 * Description : 
 * ***************************************************************************/

int8s
Kern_DeallocDev(int8u devNum)
{
CRITICAL_SECTION_ENTER();
	if(pDevTable_g[devNum] != NULL){
		MemRelease(pDevTable_g[devNum]);
		pDevTable_g[devNum] = NULL;
CRITICAL_SECTION_LEAVE();
	}else {
CRITICAL_SECTION_LEAVE();
		return FALSE;
	}

	return TRUE;
}







/*************************************************************************** 
 * Function    : 
 * Date        : 
 * Author      : 
 * Parameter   : 
 * Return value:
 * Description : 
 * ***************************************************************************/

dev_op_t *
Kern_GetDevOp(int8u devNum, int8s *err)
{
	if(pDevTable_g[devNum] != NULL){
		*err = NOERR;
		return pDevTable_g[devNum];
	}else {
		*err = NODEV;
		return NULL;
	}
}

void
Kern_IOSubBuild()
{
	Kern_RegisterDev(0,NULL,NULL,NULL,&SerialOutputString,NULL,NULL,NULL);

}
