/*************************************************************************** 
 * File        : iosubsys.h
 * Date        : 2007/04/25
 * Author      : Sun Joon Gyu
 * Modified    : 2007/04/25
 * Description : 
 * ***************************************************************************/
#ifndef _IOSUBSYS_H_
#define _IOSUBSYS_H_
#include<arch/types.h>

#define MAX_DEVICES	255
#define NOERR	1	
#define NODEV	-1


typedef struct device_operation {
	/*semahpore will be added here */
	int32s (*Create)();
	int32s (*Open)();
	int32s (*Read)();
	int32s (*Write)();
	int32s (*Close)();
	int32s (*Ioctl)();
	int32s (*Destroy)();
}dev_op_t;


dev_op_t *pDevTable_g[MAX_DEVICES];


int8s 
Kern_RegisterDev(int8u devNum,void *Dev_Create,void *Dev_Open, void *Dev_Read,
		void *Dev_Write, void *Dev_Close, void *Dev_Ioctl,void *Dev_Destroy);

int8s
Kern_DeallocDev(int8u devNum);

dev_op_t *
Kern_GetDevOp(int8u devNum, int8s *err);

#endif //_IOSUBSYS_H_
