/*************************************************************************** 
 * File        : mm.h
 * Date        : 2007/04/04
 * Author      : Sun Joon Gyu
 * Modified    : 2007/04/04
 * Description : Header file for memory management
 * ***************************************************************************/
#ifndef	_MM_H
#define _MM_H
#ifndef MM_TEST
#include<arch/types.h>
#include<kernel/list.h>
#include<arch/port.h>

#else
#include"types.h"
#include"list.h"
#endif

/* These definition is temporarily used here */
#define MEM_COMPACTION 
/*********************************************/



/**** These definitions should be moved to hardware dependant code  ********/
#define START_HEAP_ADDR		((int32u *)heap) 
#define END_HEAP_ADDR		((int32u *)((int8s *)heap+SIZE_OF_HEAP))
//#define BLOCK_SIZE		(sizeof(struct memHead)) /* Size of one block */ 
#define BLOCK_SIZE			(256) /* Size of one block */ 
#define	BLOCK_SIZE_SHIFT		(8)
#define SIZE_OF_HEAP		(1024*1024)
/*****************************************************************************/ 

#define BITS_PER_BYTE		 8
#define BACKWARD		 ((int8u)0)
#define FORWARD			 ((int8u)1)

#define INVALID			0x0
#define AVAILABLE		0x1
#define ALLOCATED		0x2

/* Definition for type of memory control block */
typedef struct memHead {
	int32u nblocks;

	struct list_head memLink;
	struct list_head allocLink;
	struct list_head freeMemLink;
	int32u threadID;	
	int32u status;		/* status of this memory control block */
	
#ifdef MEM_COMPACTION /* Not implemented yet */
	int32u *pVar;	/*the size of a tcb will be expanded if MEM_COMPACTION is defined */
#endif // MEM_COMPACTION

} memclt_t ;


extern int8s heap[];
extern bool Kern_MemInit();
extern int32u *MemAlloc(size_t size);
static memclt_t * Kern_WantedBlkFind(size_t size);
static int8s Kern_MemBlkGet(memclt_t * pBlkAddr, size_t size);

extern int8s MemRelease(void *pDesired);
static bool Kern_MemMerge(memclt_t * pPrevBlk, memclt_t * pNextBlk, int8u dir);
	
//extern int8s Kern_BlkTblRegister(memclt_t * pBlkAddr);



extern int32u *pHeapList_g;
	
#endif // _MM_H_ 
