/*************************************************************************** 
 * File        : schedule.h 
 * Date        : 2007/03/20
 * Author      : Sun Joon Gyu
 * Modified    : 2007/05/27
 * Description : 
 * ***************************************************************************/
#ifndef _SCHEDULE_H
#define _SCHEDULE_H
#include<kernel/thread.h>


#define CurrentThread()	(pCurrThread_g)
#define GetSchedPolicy() ((policy *)&sched_policy_g)
#define QUANTUM_TIME	100

typedef struct waitList {
#if 0
	tcb_t *pThreadList;
#endif
	struct list_head threadList;
	int32u nThread;
} waitList_t;


typedef enum policy {
		MIN_POLICY,
		D_RR,
		PRIO,
		EDF,
		MAX_POLICY
} policy;
extern tcb_t rdyListHead_g;
extern tcb_t *pCurrThread_g, *pNextThread_g; // Current tcb and Next tcb
extern waitList_t *pBlockedList_g;
extern policy sched_policy_g;

extern int8s Kern_Sched();
extern int8s Kern_TickIsr();    //time ͷƮ 񽺷ƾ 
extern tcb_t *Kern_FindNextTcb_t();   //nexttcb ã Լ 
extern int8s Kern_SchedulerStart();
extern int8s Kern_RdyListInit();

extern int8s Kern_WakeThread(tcb_t *thread);
extern void Sleep(int32u time);
extern int8s Kern_BlockedListInit();
extern tcb_t *Kern_GetCurrThread();
extern int8s Kern_RdyListInsert(tcb_t * newtcb);
extern int8s Kern_BlockThread(tcb_t *curr,waitList_t *pList);
extern int8s Kern_WakeThread(tcb_t *thread);
extern void TaskStart(void *data);
extern void Kern_SchedInit();

#endif // _SCHEDULE_H
