#ifndef _THREAD_H
#define _THREAD_H

#include <kernel/mm.h>
#include <arch/types.h>
#include <kernel/list.h>

#define STACK_SIZE_SHIFT	12	/*4096 bytes */
#define STACK_SIZE	(1 << STACK_SIZE_SHIFT )


typedef void (*fp_t)(void *);

typedef enum tcb_status {
		CREATED,
		READY,
		RUNNING,
		FINISHED,
		FREE
} tcb_status;


typedef struct tcb
{
		int32u *pStack;
		struct list_head threadList;

		int16u prior;
		int16u tickDly;
		int16u tid;						/* Thread ID */
        char name[16];
		tcb_status status; 				/* Current thread's status */
		struct list_head resources;	 /* Semaphore and shared memory and any 
																		other devices' resources will be 
																		linked to this.*/
		int16u deadLine;
		int32u timeSlice;
		memclt_t memList;

} tcb_t, *ptcb_t;

extern tcb_t *Kern_ThreadCreate(
				int16u tid,char *name, fp_t pT, int16u prio, int16u deadLine);		
extern void Kern_ThreadTerminate();


#endif // _THREAD_H
