/*************************************************************************************
* Function Name : 
* Date : 
* Writen by : Kim pil jou
* Argument : 
* Return type : 
* Operation :
*************************************************************************************/

#include"../thread/thread.h"
#include"../mm/mm.h"
#include"../types/types.h"
#include"scheduler.h"
#include"../interrupt/interrupt.h"



tcb_t *pCurrThread_g, *pNextThread_g; // Current tcb and Next tcb
waitList_t *pBlockedList_g;


extern tcb_t *pRdyListHead_g;
extern tcb_t *pRdyListTail_g;  // the head and tail of ReadyList


/*void *thread_1(void *arg){   //thread_1 
  for(;;){ 
    sleep(1); 
	printf("This is thread no. 1\n"); 
    } 
  } 
	
void *thread_2(void *arg){    //thread_2 
  for(;;){ 
    sleep(1); 
    printf("This is thread no. 2\n"); 
  } 
}*/


/*************************************************************************************
* Function Name : Kern_TickIsr()
* Date : `07. 4. 18
* Writen by : Kim pil jou
* Argument : No argument
* Return type : SUCCESS / FAIL
* Operation : This function is handle port's tick interrupt. tickdly decrease, if tickdly
			is zero, call Kern_Sched() and Schedule start.
*************************************************************************************/


char Kern_TickIsr(){    //time ͷƮ 񽺷ƾ 
  pCurrThread_g->tickDly--;   //tick   
  if(pCurrThread_g->tickDly == 0){   //0  Ǿ 
    Kern_Sched();  //ٷ ȣ
	pCurrThread_g = pNextThread_g;     //next tcb   tcb  
  } 
  return SUCCESS;
} 

/*************************************************************************************
* Function Name : Kern_FindNextTcb_t()
* Date : `07. 4. 18
* Writen by : Kim pil jou
* Argument : No Argument
* Return type : Next tcb_t
* Operation : This function is finding Nexttcb_t and return. finded Nexttcb_t inserted
*		ReadyList's tail. 
*
* Modified by : Sun Joon Gyu	(2007/05/27)
* 	I changed the list structure of thread control block.
* 	So, The codes for round-robin scheduling should also be changed.
*************************************************************************************/

tcb_t *Kern_FindNextTcb_t()
{   //nexttcb ã Լ 

	tcb_t *pNextThread;
	struct list_head *tempList;

	tempList = pRdyListHead_g->threadList.next;

	ListDel(pRdyListHead_g->threadList.next);
	ListAddTail(tempList,&(pRdyListHead_g->threadList));

	pNextThread = ListEntry(tempList,tcb_t,threadList);
#if 0
  pNextThread = pRdyListHead_g->pNext;

  if(pNextThread->pNext != pRdyListTail_g){
	  pRdyListHead_g->pNext = pNextThread->pNext;
	  pNextThread->pNext->pPrev= pRdyListHead_g;
  }

  if(pRdyListTail_g->pPrev != pRdyListHead_g){
	  pRdyListTail_g->pPrev->pNext = pNextThread;
	  pNextThread->pNext = pRdyListTail_g;
	  pNextThread->pPrev = pRdyListTail_g->pPrev;
	  pRdyListTail_g->pPrev = pNextThread;
  }

#endif
  return pNextThread;
   	
} 


/*************************************************************************************
* Function Name : Kern_Sched()
* Date : `07. 4. 18
* Writen by : Kim pil jou
* Argument : No Argument
* Return type : SUCCESS / FAIL
* Operation : This Function is Find Next tcb_t and port_ThreadSwitch() and Schedular start.
*************************************************************************************/


char Kern_Sched(){

/*INTERRUPT_DISABLE */
  pNextThread_g = Kern_FindNextTcb_t();

  quantum_g = 0;
  Port_ThreadSwitch();
/*INTERRUPT_ENABLE */
  return SUCCESS;
}


/*************************************************************************************
* Function Name : Kern_SchedualerStart()
* Date : `07. 4. 18
* Writen by : Kim pil jou
* Argument : No Argument
* Return type : SUCCESS / FAIL
* Operation : This Function is called Kern_Sched() and Schedular start.
*************************************************************************************/

char Kern_SchedulerStart(){
  
  Kern_Sched();

  return SUCCESS;

}


/*************************************************************************************
* Function Name : Kern_RdyListInit()
* Date : `07. 4. 18
* Writen by : Kim pil jou
* Argument : No Argument
* Return type : SUCCESS / FAIL
* Operation : This function is ReadyList initialise. this doing pRdyListhead_g and 
*		pRdyListTail_g connect. 
* 
* Modified by : Sun Joon Gyu	(2007/05/27)	
* 	I changed the list structure of thread control block.
* 	So, The codes for round-robin scheduling should also be changed.
*
*************************************************************************************/

char Kern_RdyListInit(){

	pRdyListHead_g = (tcb_t *) MemAlloc((unsigned int *)&pRdyListHead_g,sizeof(tcb_t));
  

#if 0

	pRdyListTail_g = (tcb_t *) MemAlloc((unsigned int *)&pRdyListTail_g,sizeof(tcb_t));
	pRdyListHead_g->pNext = (tcb_t *)pRdyListTail_g;
	pRdyListHead_g->pPrev = NULL;
	pRdyListTail_g->pPrev = (tcb_t *)pRdyListHead_g;
	pRdyListTail_g->pNext = NULL;
#endif 

	INIT_LIST_HEAD(&(pRdyListHead_g->threadList));




  return SUCCESS;
}





/*************************************************************************** 
 * Function    : BlockListInsert()
 * Date        : 2007/04/30
 * Author      : Sun Joon Gyu
 * Parameter   : tcb_t *thread	- a thread to be blocked
 * Return value: 
 * Description : It adds the thread from parameter to the list 'pBlockedList_g'
 * ***************************************************************************/

char
BlockedListInsert(tcb_t *thread)
{

	ListAddTail(&(thread->threadList),&(pBlockedList_g->threadList));



#if 0
	tcb_t *head = pBlockedList_g->pThreadList;
	if(head != NULL){
		thread->pNext = head;
		thread->pPrev = NULL;

		head->pPrev = thread;
		pBlockedList_g->pThreadList = thread;
	}else {
		head = thread;
		thread->pPrev = NULL;
		thread->pNext = NULL;
	}
#endif
}

tcb_t *
BlockedListRemove(tcb_t *thread)
{
	;
}



/*************************************************************************** 
 * Function    : 
 * Date        : 
 * Author      : 
 * Parameter   : 
 * Return value:
 * Description : 
 * ***************************************************************************/

char
Kern_BlockedListInit()
{
	pBlockedList_g = MemAlloc((unsigned int *)&pBlockedList_g,sizeof(struct waitList));

	INIT_LIST_HEAD(&pBlockedList_g->threadList);

}





/*************************************************************************************
* Function Name : main()
* Date : `07. 4. 18
* Writen by : Kim pil jou
* Argument : No Argument
* Return type : int
* Operation : This function is creating thread and calling Kern_SchedualerStart().
		OS start.
*************************************************************************************/
/*
int main(){
  
  Kern_ThreadCreate(*thread_1, ...);
  Kern_ThreadCreate(*thread_2, ...);
  
  Kern_SchedualerStart();

  return SUCCESS;
}

*/
